/*
 * main.c
 *
 *  Created on: 29.08.2016
 *      Author: wn
 */

#include <msp430g2553.h>
#include <stdint.h>
#include <intrinsics.h>
#include <stdlib.h>
#include <stdbool.h>

#include "gpio.h"
#include "time.h"
#include "display.h"
#include "displayMuxer.h"
#include "PontCoopScheduler.h"
#include "measure.h"
#include "eggTimer.h"
#include "button.h"
#include "gpio.h"



void powerDown(void *handleArg) {
  P1OUT = 0;
  P1DIR = 0xff;
  P1REN = 0;
  P2OUT = 0;
  P2DIR = 0xff;
  P2REN = 0;
  ADC10CTL0 = 0;

  LPM4;
  while (1);
}

int main() {
  WDTCTL = WDTPW | WDTHOLD;

  // highest possible system clock
  DCOCTL = DCO0 | DCO1 | DCO2;
  BCSCTL1 = XT2OFF | RSEL0 | RSEL1 | RSEL2 | RSEL3;
  BCSCTL2 = 0;
  BCSCTL3 = 0;


  gpioInitPins();
  timeInit();
  schInit();


  schAdd(eggTimerAlarm, NULL, 0, 37);
  schAdd(powerDown, NULL, 5000, 0);








#if 0
  // interrupts are required for delay function in displayInit();
  __enable_interrupt();
  displayInit(NULL);
  __disable_interrupt();

  measureInit(NULL);
  displayMuxerInit(NULL);
  buttonInit(NULL);
  eggTimerInit(NULL);

  schAdd(displayExec, NULL, 0, DISPLAY_CYCLE);
  schAdd(measureStartConversion, NULL, 0, MEASURE_CYCLE);
  schAdd(displayMuxerExec, NULL, 0, DISPLAY_MUXER_CYCLE);
  schAdd(eggTimerExec, NULL, 0, EGG_TIMER_CYCLE);
  schAdd(buttonExec, NULL, 0, BUTTON_CYCLE);

#endif
  __enable_interrupt();

  while (1) {
    schExec();
    LPM3;

    // put it into the idle loop, it is not time critical
    // but should get as much time as possible to avoid
    // flicker
    //displayExec(NULL);
  }
}



